// Detect It Easy Hem for Hiew
// Hem Version: 1.0
// Hem Author: exet0l
// Detect It Easy Authors: Hellsp@wn, Hors

#include <windows.h>
#include "hem.h"

/////////////////////////////////////////////////////////////////

#define HEM_DIE_VERSION_MAJOR 1
#define HEM_DIE_VERSION_MINOR 0

/////////////////////////////////////////////////////////////////

int HEM_API Hem_EntryPoint(HEMCALL_TAG *hemCall);

/////////////////////////////////////////////////////////////////

HEMINFO_TAG hemDIE = {
    sizeof(HEMINFO_TAG),
    sizeof(int),
    0,
    HEM_SDK_VERSION_MAJOR,  HEM_SDK_VERSION_MINOR,
    HEM_DIE_VERSION_MAJOR, HEM_DIE_VERSION_MINOR,
    (HEM_FLAG_MODEMASK | HEM_FLAG_FILEMASK) ^ HEM_FLAG_DISK,
    0,
    Hem_EntryPoint,
    nullptr,
    nullptr,
    0,
    0,
    0,
    0,
    "DIE",
    "Detect It Easy",
    "",
    "Hem Author: exet0l",
    "Detect It Easy Authors: Hellsp@wn, Hors"
};

/////////////////////////////////////////////////////////////////

HMODULE GetCurrentModuleHandle()
{
    HMODULE hModule;
    GetModuleHandleEx(GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS | GET_MODULE_HANDLE_EX_FLAG_UNCHANGED_REFCOUNT,
                      (LPCSTR)&GetCurrentModuleHandle, &hModule);
    return hModule;
}

void ExtractFilePath(char *fileName)
{
    int len = lstrlen(fileName);
    for (int i = len - 1; i > 0; i--) {
        if (fileName[i] == '\\') {
            fileName[i + 1] = 0;
            break;
        }
    }
}

const int BUFSIZE = 4096;
bool ReadFromDIE(char *cmdLine, char buffer[BUFSIZE])
{
    HANDLE hReadPipe;
    HANDLE hWritePipe;

    SECURITY_ATTRIBUTES sa;
    sa.nLength = sizeof(sa);
    sa.bInheritHandle = TRUE;
    sa.lpSecurityDescriptor = nullptr;

    if (!CreatePipe(&hReadPipe, &hWritePipe, &sa, 0))
        return false;

    STARTUPINFO si;
    ZeroMemory(&si, sizeof(si));
    si.dwFlags |= STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
    si.wShowWindow = SW_HIDE;
    si.hStdOutput = hWritePipe;
    si.hStdError = hWritePipe;

    PROCESS_INFORMATION pi;
    ZeroMemory(&pi, sizeof(pi));

    if (!CreateProcess(nullptr, cmdLine, nullptr, nullptr, TRUE, CREATE_NEW_CONSOLE, nullptr, nullptr, &si, &pi)) {
        CloseHandle(hReadPipe);
        CloseHandle(hWritePipe);
        return false;
    }

    WaitForSingleObject(pi.hProcess, 3000);

    ZeroMemory(&buffer[0], BUFSIZE);

    DWORD br;
    ReadFile(hReadPipe, &buffer[0], BUFSIZE, &br, nullptr);

    CloseHandle(pi.hThread);
    CloseHandle(pi.hProcess);
    CloseHandle(hReadPipe);
    CloseHandle(hWritePipe);

    return true;
}

const int MAXSTRING = 10;
typedef HEM_BYTE *Strings[MAXSTRING];
int ParseStr(char *str, Strings &strings)
{
    int strLen = lstrlen(str);
    char *pStr = &str[0];
    int stringCount = 0;

    int i = 0;
    while (i < strLen) {
        if (str[i] == '\r') {
            strings[stringCount++] = pStr;
            str[i] = '\0';

            if (stringCount == MAXSTRING)
                break;

            i += 2;
            pStr = &str[i];
        }
        i++;
    }

    if (stringCount == 0)
        strings[stringCount++] = pStr;

    return stringCount;
}

/////////////////////////////////////////////////////////////////

int HEM_EXPORT Hem_Load(HIEWINFO_TAG *hiewInfo)
{
    HiewGate_Set(hiewInfo);
    hiewInfo->hemInfo = &hemDIE;
    return HEM_OK;
}

int HEM_API Hem_EntryPoint(HEMCALL_TAG *hemCall)
{
    if (hemCall->cbSize < sizeof(HEMCALL_TAG))
        return HEM_ERROR;

    HIEWGATE_GETDATA hiewData;
    int c = HiewGate_GetData(&hiewData);
    if (c < 0)
        return c;

    HiewGate_MessageWaitOpen("Reading from DIE, please wait...");

    char myPath[MAX_PATH];
    char cmdLine[MAX_PATH * 3];
    char buffer[BUFSIZE];

    GetModuleFileName(GetCurrentModuleHandle(), myPath, MAX_PATH);
    ExtractFilePath(myPath);

    lstrcpy(cmdLine, myPath);
    lstrcat(cmdLine, "die\\diec.exe");
    lstrcat(cmdLine, " \"");
    lstrcat(cmdLine, hiewData.filename);
    lstrcat(cmdLine, "\"");
    lstrcat(cmdLine, " -showerrors:no");
    lstrcat(cmdLine, " -showentropy:yes");

    if (ReadFromDIE(cmdLine, buffer)) {
        Strings strings;
        int stringCount = ParseStr(buffer, strings);

        HiewGate_MessageWaitClose();
        HiewGate_Window("Result", strings, stringCount, 0, nullptr, nullptr);
    } else {
        HiewGate_MessageWaitClose();
        HiewGate_Message("Error", "Unable read from DIE");
    }

    return HEM_OK;
}
